unit shutdown;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type TShOs=(shWin95,shWinNT);
     TShutdownOption=(shoForce,shoLogoff,shoPoweroff,shoReboot,shoShutdown);
     TshutdownOptions=set of TShutDownOption;

type
  TShutdown = class(TComponent)
  private
  protected
    FOS:TShOs;
    FOptions: TShutdownOptions;
    FMachineName:String;
    FMessage:String;
    FTimeOut:Longint;
    FAllow:boolean;
    Timer1:TTimer;
    ShutOptions:Integer;
    procedure Timer1Timer(Sender: TObject);
    procedure ShutDown95;
  public
  published
    property OperatingSystem: TShOS read FOS write FOS default shWin95;
    property Options: TShutDownOptions read FOptions write FOptions default [];
    property NTMachineName:String read FMachineName write FMachineName;
    property MessageString:String read FMessage write FMessage;
    property TimeOut:Longint read FTimeOut write FTimeOut;
    property AllowAbort: Boolean read FALlow write FAllow default FALSE;
    function Execute:boolean;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('FreeWare', [TShutdown]);
end;


function TShutDown.Execute:boolean;
const
  ADJUST_PRIV = TOKEN_QUERY or TOKEN_ADJUST_PRIVILEGES;
  SHTDWN_PRIV = 'SeShutdownPrivilege';
  PRIV_SIZE   = sizeOf(TTokenPrivileges);
var
  Len: DWORD;
  TokenPriv, Dummy: TTokenPrivileges;
  Token: THandle;

  Text,
  Machine:array [0..128] of Char;
  Force,Reboot:boolean;

  Error:integer;

begin
 error:=0;
 if FOS=shWinNT then
  begin
  // Get a token for this process.

  // Delphi2:
  //if not OpenProcessToken(GetCurrentProcess(), ADJUST_PRIV, @Token) then
  if not OpenProcessToken(GetCurrentProcess(), ADJUST_PRIV, Token) then
      Error:=Error or 4;
    {    ShowMessage('OpenProcessToken failed');}

  // Get the LUID for the shutdown privilege.
  if not LookupPrivilegeValue(nil, SHTDWN_PRIV,TokenPriv.Privileges[0].Luid) then
    Error:=Error or 8;
    {ShowMessage('LookupPrivilegeValue failed');}

  // Adjust shutdown privilege for this process.
  TokenPriv.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
  TokenPriv.PrivilegeCount := 1;  // One privilege to set
  if not AdjustTokenPrivileges(Token, false, TokenPriv, PRIV_SIZE,Dummy, Len) then
    Error:=Error or 16;
   {ShowMessage('AdjustTokenPrivileges failed');}

  StrPCopy(Text,FMessage);
  StrPCopy(Machine,FMachineName);

  if (shoForce in FOptions) then Force:=true
                            else Force:=false;
  if (shoReboot in FOptions)then Reboot:=true
                            else Reboot:=false;
  InitiateSystemShutDown (Machine,Text,FTimeOut,Force,Reboot);
 end;

 if FOS=ShWin95 then ShutDown95;
 Result:=(Error=0);
end;



procedure TShutDown.Timer1Timer(Sender: TObject);
begin
 exitWindowsEx(ShutOptions,0);
end;



procedure TShutDown.ShutDown95;
var EOptions:integer;
begin
 EOptions:=0;

 if (shoForce in FOptions)    then EOptions:=EOptions or EWX_Force;
 if (shoLogOff in FOptions)   then EOptions:=EOptions or EWX_LogOff;
 if (shoPoweroff in FOptions) then EOptions:=EOptions or EWX_PowerOff;
 if (shoReboot in FOptions)   then EOptions:=EOptions or EWX_Reboot;
 if (shoShutdown in FOPtions) then EOPtions:=EOptions or EWX_ShutDown;

 ShutOptions:=EOptions;

 if FTimeOut<>0 then
 begin

  if Timer1=NIL then Timer1:=TTimer.Create(NIL);

  Timer1.Interval:=FTimeOut*1000;
  Timer1.Enabled:=true;
  Timer1.OnTimer:=Timer1Timer;

  if Fallow then
   if MessageDLG(FMessage,mtWarning,[mbAbort],0)=mrAbort then Timer1.Enabled:=false;

  if not(Fallow) then
  MessageDLG(FMessage,mtWarning,[],0);
 end else Timer1Timer(NIL);

end;


end.
